
;;;	EQUATES

;;	Video Screen & Color Attributes

pgnum	EQU	0	;Initial Active page #
vidmem	EQU	0B800

ATB	=	11	;ATribute Byte (display - next byte is attribute)
;;	Misc

svrs	EQU	200	;Record Size for Save & Load
lint	EQU	0E0	;Least Initiator
lint2	EQU	0E0	;Data Initiator
;;	Text

BY	EQU	<BYTE PTR>
DP	EQU	<DWORD PTR>
WP	EQU	<WORD PTR>
OF	EQU	<OFFSET>

TAB	EQU	<9>

IVQ	EQU	<1 DUP (?)>
IVQ2	EQU	<2 DUP (?)>
MPINV	EQU	<ZRF x,0>
;;;	MACROS

;;	General Purpose & Misc

GANF	MACRO			;al  +es:[di]  al ~<2 => ret
	inc	di
	mov	al, es:[di]
	cmp	al, lint2
	RETNC
	ENDM


MVAR	MACRO	n,text		;Declare Message Text
msg&n	DB	text
lmsg&n	EQU	$-msg&n
	ENDM

MIN	MACRO	dest,src	;dest  min(dest,src) dest>src ->> dest  src
	LOCAL	sk
	cmp	dest,src
	  JNAS	sk
	mov	dest, src
sk:
	ENDM
MAX	MACRO	dest,src	;dest  max(dest,src) dest<src ->> dest  src
	LOCAL	sk
	cmp	dest,src
	  JNCS	sk
	mov	dest, src
sk:
	ENDM
MAXS	MACRO	dest,src	;	signed
	LOCAL	sk
	cmp	dest, src
	  JNLS	sk
	mov	dest, src
sk:
	ENDM

MBQ	MACRO	src,set		;Set ZR if src e set
	LOCAL	end
	IRP	x,<set>
	cmp	src,x
	  JZS	end
	ENDM
end:
	ENDM
MBQR	MACRO	src,llim,ulim	;Set CY if src <llim or >ulim
	LOCAL	end
	cmp	src, llim
	  JCS	end
	cmp	src,ulim
	cmc
end:
	ENDM

RSTDS	MACRO	reg	;regx  ss	ds  regx

	IFNB	<reg>
	mov	reg&x, ss
	mov	ds, reg&x
	ELSE
	mov	ax, ss
	mov	ds, ax
	ENDIF
DSDSG	=	1
	ENDM
AXESSS	MACRO		;ax,es  ss
	mov	ax, ss
	mov	es, ax
	ENDM

CONFIRM	MACRO			;call conf	RETNZ
	call	conf
	RETNZ
	ENDM

LD	MACRO	dest,src,via
	mov	via, src
	mov	dest, via
	ENDM

GFNDC	MACRO	dest,src	;dest  fndc/src = (src-[frms])/800+fnd0

;	dest reg  end ptr for block addressed by src reg

	mov	dest, src
	IF	DSDSG EQ 1
		sub	dest, WP [frms]
		ELSE
		sub	dest, WP ss:[frms]
		ENDIF
	shr	dest, 11d
	lea	dest, [dest+OF fnd0]
	ENDM

FNDC	MACRO	reg		;reg  fndc = (es-ss:[frms])/800+fnd0
	mov	reg, es
	sub	reg, ss:[frms]
	shr	reg, 11d
	lea	reg, [(OFFSET fnd0)+reg]
	ENDM

CMPNC	MACRO	al,by2;		ret ZR,NC iff al=by2 or they are same letter
	LOCAL	end,nzend
	cmp	al,by2
	  JZS	end
	call	ltf
	  JCS	nzend
	push	ax
	xor	al, 20
	cmp	al, by2
	pop	ax
	  jmp	SHORT end
nzend:	CLRZF
end:
ENDM
;;	32 Bit

STES	MACRO	dest,reg	;Store es:reg
	mov	WP [&dest], reg
	mov	WP [&dest+2], es
	ENDM


PSHE	MACRO	reg	;ror e&reg, 10   push reg   ror e&reg, 10   push reg
	ror	e&reg, 10
	push	reg
	ror	e&reg, 10
	push	reg
	ENDM
POPE	MACRO	reg	;pop reg   shl e&reg, 10   pop reg   ror e&reg, 10
	pop	reg
	shl	e&reg, 10
	pop	reg
	ror	e&reg, 10
	ENDM

SWAP	MACRO	ereg		;ror ereg,10
	ror	ereg,10
	ENDM

ENORM	MACRO	r,use		;	erx  n(erx); e&use  0:rx
	xor	e&use, e&use	;	ENORM d,ax	eax = 0
	mov	use,&r&x	;	edx =eg 6789:F432	eax = 0:F432
	shr	e&r&x, 12d	;	edx = 6:789F
	and	&r&l, 0F0	;	edx = 6:7890
	add	e&r&x, e&use	;	edx=6:7890+0:F432 = 7:6CC2
	ENDM

; 66| 33 C0		xor	eax, eax
; 8B C2			mov	ax,dx
; 66| C1 EA 0C		shr	edx, 12d
; 80 E2 F0		and	dl, 0F0
; 66| 03 D0		add	edx, eax
SNORM	MACRO	dest,srch,srcl	;	SNORM ax,es,di	eax  es*10+di
	LOCAL	end
	xor	e&dest, e&dest	;	eax = 0		es:di =eg 6789:F432
	mov	dest, srch	;	ax  es		eax = 0:6789
	shl	e&dest, 4	;	eax = es+10	eax = 6:7890
	add	dest, srcl	;	add ax, di	ax=7890+F432 = CY:6cc2
	  JNCS	end
	add	e&dest, 10000	;			eax = 7:6CC2
end:
	ENDM
;;	Messages

WMVAR	MACRO	n
	mov	DP [msgadr], OF mvar&n
	mov	[msgln], lmvar&n
	call	wslms
ENDM
;;	Flag Clear, Set and Test

ZRF2	MACRO	f,n		;Zero (clear) Flag
	IF	DSDSG EQ 1
		IF	n LT 8
			and	BY [flg&f], NOT 1 SHL n
		ELSE
			count = n-8
			or	BY [flg&f+1], NOT 1 SHL n-8
		ENDIF
	ELSE
		count = n-8
		or	BY ss:[flg&f+1], NOT 1 SHL n-8
	ENDIF
	ENDM
SF12	MACRO	f,n		;Set Flag
	IF	DSDSG EQ 1
		IF	n LT 8
			or	BY [flg&f], 1 SHL n
		ELSE
			count = n-8
			or	BY [flg&f+1], 1 SHL n-8
		ENDIF
	ELSE
		count = n-8
		or	BY ss:[flg&f+1], 1 SHL n-8
	ENDIF
	ENDM
QF2	MACRO	f,n		;Query (test) Flag
	IF	DSDSG EQ 1
		IF	n LT 8
			test	BY [flg&f], 1 SHL n
		ELSE
			count = n-8
			test	BY [flg&f+1], 1 SHL count
		ENDIF
	ELSE
		count = n-8
		test	BY ss:[flg&f+1], 1 SHL count
	ENDIF
	ENDM
XRF2	MACRO	f,n		;Xor (change) Flag - Test after Change
	IF	DSDSG EQ 1
		IF	n LT 8
			xor	BY [flg&f], 1 SHL n
			test	BY [flg&f], 1 SHL n
		ELSE
			count = n-8
			xor	BY [flg&f+1], 1 SHL n-8
			test	BY [flg&f+1], 1 SHL n-8
		ENDIF
	ELSE
		count = n-8
		xor	BY ss:[flg&f+1], 1 SHL n-8
		test	BY ss:[flg&f+1], 1 SHL n-8
	ENDIF
	ENDM


ZRF	MACRO	f,n		;Zero (clear) Flag
	IF	DSDSG EQ 1
	and	[flg&f], NOT 1 SHL n
	ELSE
	and	ss:[flg&f], NOT 1 SHL n
	ENDIF
	ENDM
SF1	MACRO	f,n		;Set Flag
	or	ss:[flg&f], 1 SHL n
	ENDM
QF	MACRO	f,n		;Query (test) Flag
	IF	DSDSG EQ 1
	test	[flg&f], 1 SHL n
	ELSE
	test	ss:[flg&f], 1 SHL n
	ENDIF
	ENDM
XRF	MACRO	f,n		;Xor (change) Flag - Test after Change
	IF	DSDSG EQ 1
		IF	n LT 8
			xor	BY [flg&f], 1 SHL n
			test	BY [flg&f], 1 SHL n
		ELSE
			xor	WP [flg&f], 1 SHL n
			test	WP [flg&f], 1 SHL n
		ENDIF
	ELSE
		xor	WP ss:[flg&f], 1 SHL n
		test	WP ss:[flg&f], 1 SHL n
	ENDIF
	ENDM

QV	MACRO	n		;Query (test) Video flag
	IF	n LT 8
		test	BY *flg, 1 SHL n
	ELSE
		count = n-8
		test	BY *flg, 1 SHL count
	ENDIF
	ENDM

CLRZF	MACRO	;	CLeaR ZF
	push	ax
	lahf
	and	ah, 0F7
	sahf
	pop	ax
	ENDM
;;	Call, Jump and Return

;	Calls

CALLZ	MACRO	dest			;Call if ZR
	LOCAL	end
	  JNZS	end
	call	dest
end:
	ENDM
CALLNZ	MACRO	dest			;Call if NZ
	LOCAL	end
	  JZS	end
	call	dest
end:
	ENDM
CALLC	MACRO	dest			;Call if CY
	LOCAL	end
	  JNCS	end
	call	dest
end:
	ENDM
CALLNC	MACRO	dest			;Call if NC
	LOCAL	end
	  JCS	end
	call	dest
end:
	ENDM
CALLA	MACRO	dest			;Call if NCNZ
	LOCAL	end
	  JNAS	end
	call	dest
end:
	ENDM
CALLNA	MACRO	dest			;Call if ~(NCNZ)
	LOCAL	end
	  JAS	end
	call	dest
end:
	ENDM
;	Short Jumps

JZS	MACRO	dest
	jz	SHORT dest
	ENDM
JNZS	MACRO	dest
	jnz	SHORT dest
	ENDM
JCS	MACRO	dest
	jc	SHORT dest
	ENDM
JNCS	MACRO	dest
	jnc	SHORT dest
	ENDM
JSS	MACRO	dest
	js	SHORT dest
	ENDM
JNSS	MACRO	dest
	jns	SHORT dest
	ENDM
JAS	MACRO	dest
	ja	SHORT dest
	ENDM
JNAS	MACRO	dest
	jna	SHORT dest
	ENDM
JBES	MACRO	dest
	jbe	SHORT dest
	ENDM
JNBES	MACRO	dest
	jnbe	SHORT dest
	ENDM
JLS	MACRO	dest
	jl	SHORT dest
	ENDM
JNLS	MACRO	dest
	jnl	SHORT dest
	ENDM
JAES	MACRO	dest
	jae	SHORT dest
	ENDM
JLES	MACRO	dest
	jle	SHORT dest
	ENDM
JGS	MACRO	dest
	jg	SHORT dest
	ENDM
JNGS	MACRO	dest
	jng	SHORT dest
	ENDM
JPES	MACRO	dest
	jpe	SHORT dest
	ENDM
JNPES	MACRO	dest
	jpo	SHORT dest
	ENDM
;	Returns

RETZ	MACRO				;Ret if ZR
	LOCAL	end
	  JNZS	end
	retn
end:
	ENDM
RETC	MACRO				;Ret if CF
	LOCAL	end
	  JNCS	end
	retn
end:
	ENDM
RETS	MACRO				;Ret if S=1
	LOCAL	end
	  JNSS	end
	retn
end:
	ENDM
RETNS	MACRO				;Ret if S=0
	LOCAL	end
	  JSS	end
	retn
end:
	ENDM
RETNZ	MACRO				;Ret if NZ
	LOCAL	end
	  JZS	end
	retn
end:
	ENDM
RETNC	MACRO				;Ret if CF
	LOCAL	end
	  JCS	end
	retn
end:
	ENDM
RETCZ	MACRO				;Ret if CF or ZR
	LOCAL	end			;  ja = jump if NC & NZ
	  JAS	end
	retn
end:
	ENDM
RETA	MACRO				;Ret if >
	LOCAL	end			;  ja = jump if NC & NZ
	  JNAS	end
	retn
end:
	ENDM
RETNA	MACRO				;Ret if ~>
	LOCAL	end			;  ja = jump if NC & NZ
	  JAS	end
	retn
end:
	ENDM
RETCXZ	MACRO				;Ret if cx=0
	LOCAL	end,rend
	  jcxz	rend
	  jmp	SHORT end
rend:	retn
end:
	ENDM
;	DJNZ & DJZ

DJNZ	MACRO	counter,dest		;dec counter: jnz dest
	dec	counter
	  JNZS	dest
	ENDM
DJZ	MACRO	counter,dest		;dec counter: jz dest
	dec	counter
	  JZS	dest
	ENDM
;;	Block Moves & Scans

COMMENT`
;	BMV			Efficient Block MoVe Up

BMV	MACRO
	LOCAL	sk1,sk2
;		ecx=0 => erbeep

	or	ecx, ecx
	  jz	erbeep
;		shr ecx			jnc sk1			movsb

	shr	ecx, 1
	  jnc	sk1
	movsb
;   sk1:	shr ecx			jnc sk2			movsw

sk1:
	shr	ecx, 1
	  jnc	sk2

	movsw
;   sk2:	rep movsd

sk2:
	rep movsd
	ENDM

;	BMVD				Down

BMVD	MACRO
	LOCAL	sk1,sk2
;		std			shr cx			jnc sk1

	std
	shr	cx, 1
	  JNCS	sk1
;		movsb

	movsb
;   sk1:	dec di,si		shr cx			jnc sk2

sk1:	dec	di
	dec	si
	shr	cx, 1
	  JNCS	sk2
;		movsw

	movsw
;   sk2:	dec di,2		dec si,2		rep movsd

sk2:	dec	di
	dec	di
	dec	si
	dec	si
	rep movsd
;		add di,	3		add si,	3		cld

	add	di, 3
	add	si, 3
	cld
	ENDM

;	BMVR				Up - w/	Rectification

BMVR	MACRO				;dl = rectification factor  ds:si = src
	LOCAL	bmvr,sk,end

;		cx=0 => end
	  jcxz	end
;   bmvr:	lodsb			al< => sk		add al, dl

bmvr:	lodsb				;  es:di = dest  cx = count
	cmp	al, lint
	  JCS	sk
	add	al, dl
;   sk:		stosb			loop bmvr

sk:	stosb
	loop	bmvr
end:
	ENDM
;	BMVDR				Down w/	Rectification

;		std			BMVR			cld
BMVDR	MACRO				;dl = rectification factor  ds:si = src
	std
	BMVR
	cld
	ENDM
`

;	BMV			Efficient Block MoVe Up

BMV	MACRO
	LOCAL	sk1,sk2
;		shr ecx			jnc sk1			movsb

	shr	ecx, 1

	  jnc	sk1

	movsb
;   sk1:	shr ecx			jnc sk2			movsw

sk1:
	shr	ecx, 1

	  jnc	sk2

	movsw
;   sk2:	rep movsd

sk2:
	rep movsd
	ENDM

;	BMVD					     Down

BMVD	MACRO
	LOCAL	sk1,sk2
;		std			shr ecx

	std

	shr	ecx, 1
;		jnc sk1			movsb

	  jnc	sk1

	movsb
;   sk1:	dec edi,esi		shr ecx			jnc sk2

sk1:
	dec	edi
	dec	esi

	shr	ecx, 1

	  jnc	sk2
;		movsw

	movsw
;   sk2:	dec edi,2		dec esi,2		rep movsd

sk2:
	dec	edi
	dec	edi

	dec	esi
	dec	esi

	rep movsd
;		add edi, 3		add esi, 3		cld

	add	edi, 3

	add	esi, 3

	cld
	ENDM

;	BMVR				Up - w/	Rectification

BMVR	MACRO			;dl = rectification factor
	LOCAL	bmvr,sk,end	;esi = src	edi = dest	ecx = len

;		ecx=0 => end

	  jecxz	end
;   bmvr:	lodsb			al< => sk		add al, dl

bmvr:
	lodsb

	cmp	al, lint
	  jc	sk

	add	al, dl
;   sk:		stosb			loop bmvr

sk:
	stosb

	loop	bmvr
;   end:

end:
	ENDM
;	BMVDR				Down w/	Rectification

;		std			BMVR			cld

BMVDR	MACRO
	std
	BMVR
	cld
	ENDM
;;	In/Out

OUTM	MACRO	port,value		;value -> port via al
	mov	al, value
	out	port, al
	ENDM

OUTXX	MACRO				;out dx, al  out E1, ax
	out	dx, al
	out	0E1, ax
	ENDM
INXX	MACRO				;in al, dx  out E1, ax
	in	al, dx
	out	0E1, ax
	ENDM
BEEPM	MACRO	dur
	LOCAL	lp

;   tonon	OUTM 43,B6		OUTM 42,0

	OUTM	43, 0B6			;'magic #' -> timer2
	OUTM	42, 0			;cycles/lsb
;		OUTM 42,4		in al, 61		or al, 3

	OUTM	42, 4			;cycles/msb

	in	al, 61			;spkr port

	or	al, 3			;spkr/timer on
;		out 61, al		dl  dur	<dur>="" ->> dl  8

	out	61, al

	mov	dl, 8
	IFNB	<dur>
	mov	dl,dur
	ENDIF
;   waitdl	cx  0

	xor	cx,cx
;   lp:		loop lp			DJNZ dl,lp

lp:
	loop	lp

	DJNZ	dl,lp

;   tonoff	in al, 61		and al, 0FC

	in	al, 61			;get port

	and	al, 0FC			;spkr/timer2 off
;		out 61, al

	out	61, al
	ENDM
;;;	STRUCTURES

dtwd	STRUC		;Data/Templat Window Data
buf	DW	?		;+0 BuFfer address
tmw	DW	?		;+2 template width (words)
dtw	DW	?		;+4 data width (words)
hgt	DB	?		;+6 height
tcl	DB	?		;+7 template color bk/g
dcl	DB	?		;+8 data color bk/g
	DB	0		;+9 EMPhasis
skmp	DB	0		;+A skipmap
voff	DB	0		;+B Vertical OFFset
hoff	DW	0		;+C Horizontal OFFset
unu	DB	0		;+E UNUsed hpos
flg	DB	0		;+F FLaG - attributes of wdw
;	7   6	5   4		3   2	1   0
;	r/l trs t/b
dtwd	ENDS			;10 byte structure
mhwd	STRUC		;Menu/Help Window Data
buff	DW	?		;+0 BUFFer address
hrsz	DB	?		;+2 HoRizontal SiZe (words)
vcsz	DB	?		;+3 VertiCal SiZe
wclr	DB	?		;+4 Window CoLoR
wflg	DB	?		;+5	   FLaG
wvof	DB	?		;+6	   Vertical Offset
hvof	DB	?		;+6	   Horizontal Offset
mhwd	ENDS			;8 byte structure

